package java.nio;

import sun.nio.ch.DirectBuffer;

class DirectIntBufferRU extends DirectIntBufferU implements DirectBuffer
{
    DirectIntBufferRU(DirectBuffer directBuffer, int n, int n2, int n3, int n4, int n5) {
        super(directBuffer, n, n2, n3, n4, n5);
    }
    
    @Override
    public IntBuffer slice() {
        int position = this.position();
        int limit = this.limit();
        int n = (position <= limit) ? (limit - position) : 0;
        int n2 = position << 2;
        assert n2 >= 0;
        return new DirectIntBufferRU(this, -1, 0, n, n, n2);
    }
    
    @Override
    public IntBuffer duplicate() {
        return new DirectIntBufferRU(this, this.markValue(), this.position(), this.limit(), this.capacity(), 0);
    }
    
    @Override
    public IntBuffer asReadOnlyBuffer() {
        return this.duplicate();
    }
    
    @Override
    public IntBuffer put(int n) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public IntBuffer put(int n, int n2) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public IntBuffer put(IntBuffer intBuffer) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public IntBuffer put(int[] array, int n, int n2) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public IntBuffer compact() {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public boolean isDirect() {
        return true;
    }
    
    @Override
    public boolean isReadOnly() {
        return true;
    }
    
    @Override
    public ByteOrder order() {
        return (ByteOrder.nativeOrder() != ByteOrder.BIG_ENDIAN) ? ByteOrder.LITTLE_ENDIAN : ByteOrder.BIG_ENDIAN;
    }
}
